/*********************************************************************
 * Desktop Station Buzzer Library for Arduino
 *
 * Copyright (C) 2014 Yaasan
 * Not use for commercial use
 */

#ifndef DSBUZEER_H
#define DSBUZEER_H

#include <Arduino.h>


typedef struct
{
	byte mNo;
	byte mTone;
	byte mInterval; //50ms interval count
	bool mAnalog;
	unsigned short mLength;
} SOUND_DATA;


const signed char buzzer_data[] PROGMEM =
	{ 
		64, 2,
		90, 2,
		32, 2,
		128, 2,
		64, 4,
		90, 4,
		32, 4,
		128, 4,
	};


class DSBuzzer
{
  private:
	unsigned long gTime_Interval;
	int gCount;
	int gCount_length;
	SOUND_DATA gSoundData;
	
	void soundWrite( int inPin, int inValue);
	
  public:
	DSBuzzer();
	
	void Init();
	void Scan();
	void Register(byte inTone, byte inInterval, unsigned short inLength);
	void Register(byte inNo, unsigned short inLength);

};

#endif
